/* Generated: Mon Dec 09 2024 15:18:07 GMT-0700 (Mountain Standard Time) */
/* Will not be regenerated. */

#include "phidgetbase.h"
#include "util/ledarraysupport.h"
#include "class/ledarray.gen.h"
#include "class/ledarray.gen.c"

static void CCONV
PhidgetLEDArray_errorHandler(PhidgetChannelHandle phid, Phidget_ErrorEventCode code) {
}

static void CCONV
PhidgetLEDArray_free(PhidgetChannelHandle *ch) {

	if (ch && *ch)
		PhidgetLEDArraySupport_free((PhidgetLEDArraySupportHandle *)&(*ch)->private);
	_free(ch);
}

API_PRETURN
PhidgetLEDArray_create(PhidgetLEDArrayHandle *phidp) {
	PhidgetReturnCode res;

	res = _create(phidp);
	if (res == EPHIDGET_OK)
		res = PhidgetLEDArraySupport_create((PhidgetLEDArraySupportHandle *)&(*phidp)->phid.private);

	return (res);
}

static PhidgetReturnCode CCONV
PhidgetLEDArray_setStatus(PhidgetChannelHandle phid, BridgePacket *bp) {
	return (_setStatus(phid, bp));
}

static PhidgetReturnCode CCONV
PhidgetLEDArray_getStatus(PhidgetChannelHandle phid, BridgePacket **bp) {
	return (_getStatus(phid, bp));
}

static PhidgetReturnCode CCONV
PhidgetLEDArray_initAfterOpen(PhidgetChannelHandle phid) {
	return (_initAfterOpen(phid));
}

static PhidgetReturnCode CCONV
PhidgetLEDArray_setDefaults(PhidgetChannelHandle phid) {
	return (_setDefaults(phid));
}

static PhidgetReturnCode
PhidgetLEDArray_bridgeInput(PhidgetChannelHandle phid, BridgePacket *bp) {
	PhidgetReturnCode res;

	switch (bp->vpkt) {
	default:
		res = _bridgeInput(phid, bp);
		break;
	}

	return (res);
}

static void CCONV
PhidgetLEDArray_fireInitialEvents(PhidgetChannelHandle phid) {
	_fireInitialEvents(phid);
}

static int CCONV
PhidgetLEDArray_hasInitialState(PhidgetChannelHandle phid) {
	return (_hasInitialState(phid));
}

API_PRETURN
PhidgetLEDArray_setLEDs(PhidgetLEDArrayHandle ch, const PhidgetLEDArray_RGB *leds, size_t ledCount, uint32_t fadeTime) {
	size_t i;

	TESTPTR_PR(ch);
	TESTCHANNELCLASS_PR(ch, PHIDCHCLASS_LEDARRAY);
	TESTATTACHED_PR(ch);

	if (ledCount > BPE_MAXARRAY_LEN / 3)
		return EPHIDGET_INVALIDARG;

	uint8_t buffer[BPE_MAXARRAY_LEN];
	for (i = 0; i < ledCount; i++) {
		buffer[(i * 3) + 0] = leds[i].r;
		buffer[(i * 3) + 1] = leds[i].g;
		buffer[(i * 3) + 2] = leds[i].b;
	}

	return bridgeSendToDevice((PhidgetChannelHandle)ch, BP_DATAOUT, NULL, NULL, 2, "%d%*R", fadeTime, (ledCount * 3), buffer);
}

API_PRETURN
PhidgetLEDArray_setAnimation(PhidgetLEDArrayHandle ch, const PhidgetLEDArray_RGB *pattern, size_t patternCount, PhidgetLEDArray_AnimationDescription animation) {

	size_t i;

	TESTPTR_PR(ch);
	TESTCHANNELCLASS_PR(ch, PHIDCHCLASS_LEDARRAY);
	TESTATTACHED_PR(ch);

	if (patternCount > BPE_MAXARRAY_LEN / (3 * 16))
		return EPHIDGET_INVALIDARG;

	uint8_t buffer[BPE_MAXARRAY_LEN];
	for (i = 0; i < patternCount; i++) {
		buffer[(i * 3) + 0] = pattern[i].r;
		buffer[(i * 3) + 1] = pattern[i].g;
		buffer[(i * 3) + 2] = pattern[i].b;
	}

	return bridgeSendToDevice((PhidgetChannelHandle)ch, BP_SETANIMATION, NULL, NULL, 7, "%d%d%d%d%d%d%*R", animation.animationNumber, animation.startAddress,
							  animation.span, animation.pixelSize, animation.time, animation.animationType, (patternCount * 3), buffer);
}