#ifndef _LEDARRAY_H_
#define _LEDARRAY_H_
#ifdef INCLUDE_PRIVATE
typedef struct _PhidgetLEDArray *PhidgetLEDArrayHandle;

/* Methods */
API_PRETURN_HDR PhidgetLEDArray_create(PhidgetLEDArrayHandle *ch);
API_PRETURN_HDR PhidgetLEDArray_delete(PhidgetLEDArrayHandle *ch);
API_PRETURN_HDR PhidgetLEDArray_setAnimation(PhidgetLEDArrayHandle ch, const PhidgetLEDArray_RGB *pattern,
  size_t patternCount, PhidgetLEDArray_AnimationDescription animationDescription);
API_PRETURN_HDR PhidgetLEDArray_setLEDs(PhidgetLEDArrayHandle ch, const PhidgetLEDArray_RGB *leds,
  size_t ledCount, uint32_t fadeTime);
API_PRETURN_HDR PhidgetLEDArray_synchronizeAnimation(PhidgetLEDArrayHandle ch);

/* Properties */
API_PRETURN_HDR PhidgetLEDArray_setEnabled(PhidgetLEDArrayHandle ch, int enabled);
API_PRETURN_HDR PhidgetLEDArray_getEnabled(PhidgetLEDArrayHandle ch, int *enabled);
API_PRETURN_HDR PhidgetLEDArray_getMinFadeTime(PhidgetLEDArrayHandle ch, uint32_t *minFadeTime);
API_PRETURN_HDR PhidgetLEDArray_getMaxFadeTime(PhidgetLEDArrayHandle ch, uint32_t *maxFadeTime);
API_PRETURN_HDR PhidgetLEDArray_getMinLEDCount(PhidgetLEDArrayHandle ch, uint32_t *minLEDCount);
API_PRETURN_HDR PhidgetLEDArray_getMaxLEDCount(PhidgetLEDArrayHandle ch, uint32_t *maxLEDCount);
API_PRETURN_HDR PhidgetLEDArray_setProtocol(PhidgetLEDArrayHandle ch,
  PhidgetLEDArray_Protocol protocol);
API_PRETURN_HDR PhidgetLEDArray_getProtocol(PhidgetLEDArrayHandle ch,
  PhidgetLEDArray_Protocol *protocol);

/* Events */

#endif /* INCLUDE_PRIVATE */
#endif /* _LEDARRAY_H_ */
